#include <stdio.h>
#include <stdlib.h>
/* #include <malloc.h>	mrm: ANSI says this stuff should be in stdlib.h */
#include "arrayutl.h"

/* allocate vector of type float with indices that run from 0 to high
*/
char *cvec(high)
int high;
{
        char *hold;
        hold=(char *)calloc((unsigned) (high+1), sizeof(char));
        if (!hold) printf("Allocation error in cvec()\n");
        return hold;
}

/* free vector of type float with indices that run from 0 to high */
void freecvec(vecname)
char *vecname;
{
   free((char*) (vecname));
}


/* allocate vector of type float with indices that run from 0 to high */
float *fvec(high)
int high;
{
	float *hold;
	hold=(float *)calloc((unsigned) (high+1), sizeof(float));
	if (!hold) printf("Allocation error in fvec()\n");
	return hold;
}

/* free vector of type float with indices that run from 0 to high */
void freefvec(vecname)
float *vecname;
{
   free((char*) (vecname));
}

/* allocate vector of type double with indices that run from 0 to high */
double *dvec(high)
int high;
{
	double *hold;
	hold=(double *)calloc((unsigned) (high+1), sizeof(double));
	if (!hold) printf("Allocation error in dvec()\n");
	return hold;
}

/* free vector of type double with indices that run from 0 to high */
void freedvec( double *vecname )
{
	if( vecname != NULL ) {
		free((char*) (vecname)) ;
	}
}

/* allocate vector of type int with indices that run from 0 to high */
int *ivec(high)
int high;
{
	int *hold;
	hold=(int *)calloc((unsigned) (high+1), sizeof(int));
	if (!hold) printf("Allocation error in ivec()\n");
	return hold;
}

/* free vector of type float int with indices that run from 0 to high */
void freeivec(vecname)
int *vecname;
{
   free((char*) (vecname));
}

/* allocate float matrix with indices that run 0->highrow, 0-> highcol */
float **fmat(highrow,highcol)
int highrow, highcol;
{
   int ktrack;
   float **hold;
   hold =(float **) calloc((unsigned) (highrow+1), sizeof(float*));
   if (!hold) printf("Allocation Failure in fmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(float *) calloc((unsigned) (highcol+1), sizeof(float));
      if (!hold[ktrack]) printf("Allocation Failure in fmat()\n");
   }
   return hold;
}

/* free float matrix with indices that run 0->highrow, 0-> highcol */
void freefmat(matname,highrow,highcol)
int highrow, highcol;
float **matname;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}

 
/* free char matrix with indices that run 0->highrow, 0-> highcol */
void freecmat(matname,highrow,highcol)
char **matname;
int highrow, highcol;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*)
(matname[ktrack]));
   free((char*) (matname));
}
 

/* allocate char matrix with indices that run 0->highrow, 0-> highcol */
char **cmat(highrow, highcol)
int highrow, highcol;
{
   int ktrack;
   char **hold;
   hold =(char **) calloc((unsigned) (highrow+1), sizeof(char*));
   if (!hold) {
   		printf("Allocation Failure in cmat()\n");
   		return( NULL ) ;
   }
   
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(char*) calloc((unsigned) (highcol+1), sizeof(char));
      if (!hold[ktrack]) {	
      	printf("Allocation Failure in cmat()\n") ;
      	hold = NULL ;
      }
   }
   return hold;
}

/* allocate three-d integer matrix with indice that run 0->high,0->highrow,
            0-> highcol */
int ***threeimat(high,highrow,highcol)
int high,highrow,highcol;
{
   int ktrack,ktrack2;
   int ***hold3;
   hold3 =(int ***) calloc((unsigned) (high+1), sizeof(int**));
   if (!hold3) printf("Allocation Failure in threeimat()\n");
   for(ktrack=0; ktrack<= high; ktrack++)
   {
      hold3[ktrack]=(int **) calloc((unsigned) (highrow+1), sizeof(int*));
      if (!hold3[ktrack]) printf("Allocation Failure in threeimat()\n");
      for(ktrack2=0;ktrack2<=highrow;ktrack2++)
      {
         hold3[ktrack][ktrack2] = (int *) calloc((unsigned) (highcol+1), sizeof(int));
         if (!hold3[ktrack][ktrack2])
            printf("Allocation Failure in threeimat()\n");
      }
   }   
   return hold3;
}

/* allocate four-d double matrix with indice that run 0->high1, 0-> high2,
0->highrow, 0-> highcol */
double ****fourdmat(high1, high2,highrow,highcol)
int high1, high2,highrow,highcol;
{
   int ktrack,ktrack2, ktrack3;
   double ****hold4;
   hold4 =(double ****) calloc((unsigned) (high1+1), sizeof(double***));
   if (!hold4) 
   {
      printf("Allocation Failure in fourdmat()\n");
   }
   else
   {
      for(ktrack=0; ktrack<= high1; ktrack++)
      {
         hold4[ktrack]=(double ***) calloc((unsigned) (high2+1), sizeof(double**));
         if (!hold4[ktrack]) 
         {
            printf("Allocation Failure in fourdmat()\n");
            break;
         }
         for(ktrack2=0;ktrack2<=high2;ktrack2++)
         {
            hold4[ktrack][ktrack2] = (double **) calloc((unsigned) (highrow+1), sizeof(double*));
            if (!hold4[ktrack][ktrack2]) 
            {
               printf("Allocation Failure in fourdmat()\n");
               break;
            }
            for(ktrack3=0; ktrack3<=highrow; ktrack3++) 
            {
               hold4[ktrack][ktrack2][ktrack3] = (double *) calloc((unsigned) (highcol+1), 
               															sizeof(double));
            }
         }
      }
   }
   return hold4;
}

/* allocate three-d double matrix with indice that run 0->high,0->highrow,
            0-> highcol */
double ***threedmat(high,highrow,highcol)
int high,highrow,highcol;
{
   int ktrack,ktrack2;
   double ***hold3;
   hold3 =(double ***) calloc((unsigned) (high+1), sizeof(double**));
   if (!hold3) printf("Allocation Failure in threedmat()\n");
   for(ktrack=0; ktrack<= high; ktrack++)
   {
      hold3[ktrack]=(double **) calloc((unsigned) (highrow+1), sizeof(double*));
      if (!hold3[ktrack]) printf("Allocation Failure in threedmat()\n");
      for(ktrack2=0;ktrack2<=highrow;ktrack2++)
      {
         hold3[ktrack][ktrack2] = (double *) calloc((unsigned)(highcol+1), sizeof(double));
         if (!hold3[ktrack][ktrack2]) 
            printf("Allocation Failure in threedmat()\n");
      }
   }
   return hold3;
}


 
 
/* allocate double matrix with indices that run 0->highrow, 0-> highcol */
double **dmat( int highrow, int highcol )
{
	int		ktrack, j ;
	double	**hold ;
	
	hold = (double **) calloc( (unsigned) (highrow+1), sizeof(double*) ) ;
	if ( !hold ) {
		fprintf( stderr, "Allocation Failure in dmat()\n" ) ;
		return( NULL ) ;
	}
	
	for( ktrack=0 ; ktrack <= highrow ; ktrack++ ) {
		hold[ktrack] = (double *) calloc( (unsigned) (highcol+1), sizeof(double) ) ;
		
		if ( !hold[ktrack] ) {
			fprintf( stderr, "Row Allocation Failure in dmat()\n" ) ;
			for( j = ktrack ; j >= 0 ; j-- )
				free( hold[j] ) ;
				
			free( hold ) ;
			return( NULL ) ;	
		}
	}
	
	return hold ;
}

/* free double matrix with indices that run 0->highrow, 0-> highcol */
void freedmat( double **matname, int highrow, int highcol )
{
	int ktrack;
   
	if( matname != NULL ) {
		for( ktrack = highrow ; ktrack >= 0 ; ktrack-- ) {
			if( matname[ktrack] != NULL ) {
				free((char*) (matname[ktrack])) ;
			}
		}
		
		free( (char*) matname ) ;
	}
}

 
/* free 3d integer matrix with indices 0->high, 0->highrow, 0-> highcol */
void freethreeimat(matname, high,highrow, highcol)
int ***matname;
int high, highrow, highcol;
{
   int ktrack,ktrack2;
   for(ktrack=high;ktrack>=0;ktrack--)
   {
      for(ktrack2=highrow;ktrack2>=0;ktrack2--) free((char*)
         (matname[ktrack][ktrack2]));
      free((char*) (matname[ktrack]));
   }
   free((char*) (matname));
}

/* free 4d double matrix with indices 0->high1, 0-> high2, 0->highrow, 
   0-> highcol */
void freefourdmat(matname, high1, high2, highrow, highcol)
double ****matname;
int high1, high2, highrow, highcol;
{
   int ktrack,ktrack2,ktrack3;
   for(ktrack=high1;ktrack>=0;ktrack--) 
   {
      for(ktrack2=high2;ktrack2>=0;ktrack2--) 
      {
         for(ktrack3=highrow;ktrack3>=0; ktrack3--)
         {
            free((char*) (matname[ktrack][ktrack2][ktrack3]));
         }
         free((char*) (matname[ktrack][ktrack2]));
      }
      free((char*) (matname[ktrack]));
   }
   free((char*) (matname));
}  

/* free 3d double matrix with indices 0->high, 0->highrow, 0-> highcol */
void freethreedmat(matname, high,highrow, highcol)
double ***matname;
int high, highrow, highcol;
{
   int ktrack,ktrack2;
   for(ktrack=high;ktrack>=0;ktrack--) 
   {
      for(ktrack2=highrow;ktrack2>=0;ktrack2--) free((char*) 
         (matname[ktrack][ktrack2]));
      free((char*) (matname[ktrack]));
   }
   free((char*) (matname));
}  

/* allocate int matrix with indices that run 0->highrow, 0-> highcol */
int **imat( int highrow, int highcol )
{
   int ktrack;
   int **hold;
   /* hold =(int **) calloc((unsigned) (highrow+1), sizeof(int*)); */
   hold =(int **) calloc((size_t) (highrow+1), sizeof(int*));
   if (!hold) {
   		printf("Allocation Failure in imat()\n");
   		return( NULL ) ;
   	}
   	
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      /* hold[ktrack]=(int *) calloc((unsigned) (highcol+1), sizeof(int)); */
      hold[ktrack]=(int *) calloc((size_t) (highcol+1), sizeof(int));
      if (!hold[ktrack]) {	
      	printf("Allocation Failure in imat()\n");
      	return( NULL ) ;
      }
   }
   return hold;
}

/* free int matrix with indices that run 0->highrow, 0-> highcol */
void freeimat(matname, highrow, highcol)
int **matname,highrow, highcol;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}
