#include <stdio.h>

void invert( double **a, int nsize )
{
  int i, j, k, lower, upper;
  double temp;

  /*Gauss-Jordan reduction -- invert matrix a in place,
         overwriting previous contents of a.  On exit, matrix a
         contains the inverse.*/
  lower = 0;
  upper = nsize;
  for (i = lower; i <= upper; i++) {
    temp = 1.0 / a[i][i];
    a[i][i] = 1.0;
    for (j = lower; j <= upper; j++) {
      a[i][j] *= temp;
    }
    for (j = lower; j <= upper; j++) {
      if (j != i) {
	temp = a[j][i];
	a[j][i] = 0.0;
	for (k = lower; k <= upper; k++) {
	  a[j][k] -= temp * a[i][k];
	}
      }
    }
  }
}  /*invert*/

