/*****************************************************
*	A header describing some utility functions used 
* to read parameter files.
*
* mrm: LANL, 12 April 1999
*/
# ifndef _mrm_utils_	/* Include these lines just once */
# define _mrm_utils_
/*******************************************************
*	A macro that makes a simple check to see if all
* attempts to read data have been successful.
*/

# define cmd_okay()			(cmd_all_well)

extern int		cmd_all_well ;

/***************************************************************
*	Sizes used in mrm_utils.c and divtime.c
*/
# define LINE_BUF_SIZE	2048
# define MAX_TOKENS		(1 + (LINE_BUF_SIZE)/2)

/***************************************************************
*	Prototypes from mrm_utils.c
*/
double get_double(FILE *fp);
char get_char(FILE *fp);
int get_int(FILE *fp);
long get_long(FILE *fp);
void get_name(char *name, int length, FILE *fp);
char *value_token(char *line);
int line_to_tokens(char *line, char *tokens[]);
void remove_C_comments(char *line);
char *get_next_value(char *line, int length, FILE *fp);
void trim_comments(char *line);
int get_tokens(char *tokens[], size_t max_tokens, char *line);
int read_val_list(FILE *fp, double *array, size_t vals_to_read);
char *strip_ends(char *line);
int dbl_cmpr(const void *a, const void *b);

# endif /* _mrm_utils_ */
