/*******************************************************
*	A header for a circle of random number 
* generation routines.
*
* mrm, UMIST, 23 June, 1998
*/

# ifndef _Random_nums_	/* include these lines just once */
# define _Random_nums_
/*******************************************************
*	Make sure that size_t has been defined.
*/
# include <stddef.h>

/*******************************************************
*	Define the floating-point type to use when
* returning random numbers.
*/
typedef double	Rand_type ;

/*******************************************************
*	The useful constant two_pi should be computed by 
* the initialization routine, init_random(), and then
* made available through this header.
*/
extern double	two_pi ;

/*******************************************************
*	Prototypes: the table_o versions fill array all at
* a stroke, with an eye to reducing overheads.
*/
	/* from some specific generator, say, MT_random.c */
extern void init_random(unsigned long seed);
extern void table_o_std_uniform(Rand_type *table, size_t n_val);
extern Rand_type std_uniform(void);

	/* from random.c */
extern Rand_type gaussian(double mu, double sigma);
extern Rand_type std_normal(void);
extern Rand_type uniform(double min, double max);
extern Rand_type log_normal(double mean, double var);

extern void table_o_gaussian(Rand_type *table, size_t n_vals, double mu, double sigma);
extern void table_o_std_normal(Rand_type *table, size_t n_vals);
extern void table_o_uniform(Rand_type *table, size_t n_vals, double min, double max);
extern void table_o_log_normal(Rand_type *table, size_t n_vals, double mu_x, double sigma_x);

# endif /* ifndef _Random_nums_ */
