/*****************************************************
*	Here are prototypes for the externally visible 
* functions from tree_loglike.c. They are used to 
* make a quadratic approximation to a tree's 
* log-likelihood as a function of the lengths 
* of its branches.
*
* 	mrm:	29 July, UMIST
*			31 October, Whalley Range
*/

# ifndef _Tree_LogLike_	/* Include these lines just once */
# define _Tree_LogLike_
/************************************************
*	Make sure FILE has been defined as we
* need it in one fo the prototypes below.
*/
# include <stdio.h>	

double delta_tree_loglike(double *crnt_x, double new_x, int pos);
double vect_delta_tree_loglike(double *crnt_x, double *new_x, int *changes, int N_changes);
int init_tree_loglike(int dim, double *max_pos, double *gradient, double *covar);
int file_init_tree_loglike(int dim, FILE *fp);
void tll_copy_max_pos(double *pos);
double tree_loglike(double *x);

# endif /* ifndef _Tree_LogLike_ */
